"use strict";
{
    self.C3.Plugins.Sparsha_External_Image.Acts = {
        async LoadUrl(url, id)
        {
            var self = this;
            var oReq = new XMLHttpRequest();
            await oReq.open("GET", url, true);
            oReq.responseType = "blob";
            oReq.onload = function(oEvent)
            {
                var BlobHere = oReq.response;
                if (BlobHere)
                {
                    createImageBitmap(BlobHere).then(response => {
                        self.myID = id;
                        self.myObjName = self._objectClass._name;
                        globalThis.myImageBitmap[self.myObjName][self.myID] = response;
                        self.myW = response.width;
                        self.myH = response.height;
                        self.isLoaded = true;
                        self.isNew = true;
                        self._runtime.UpdateRender();
                        self.Trigger(self.PluginCnds.OnLoaded);
                    })
                }
            };
            oReq.onerror = function()
            {
                self.Trigger(self.PluginCnds.OnError);
            }
            oReq.send();
        },

        LoadIID(id)
        {
            var self = this;
            self.myObjName = self._objectClass._name;
            self.myID = id;
            self.isLoaded = true;
            self.isNew = true;
            self._runtime.UpdateRender();
        },

        DestroyData(id)
        {
            delete globalThis.myImageBitmap[this._objectClass._name][id];
        },

        DestroyAll()
        {
            delete globalThis.myImageBitmap[this._objectClass._name];
        },

        LoadObject(obj, id)
        {
            var self = this;
            self.myObjName = obj._name;
            self.myID = id;
            self.isLoaded = true;
            self.isNew = true;
            self._runtime.UpdateRender();
        }
    };
}